// Implementacja tego interfejsu w jakiej klasie
// dostarczy definicji metody do wykonania w wtku
interface Command {
  public void execute();
}

// Klasa przerywalnych wtkw
// wykonujcych powtarzalne czynnoci
class InterruptibleRepetitiveThread extends Thread {

  // obiekt dostarczajcy definicji czynnoci
  private Command command;

  // Muteks do synchronizacji wait
  // Potrzebny jedynie dla zapewnienia regu skadniowych
  // Obiekt ten na pewno nie bdzie wspldzielony!
  private final Object waitMutex = new Object();

  // Czstotliwo powtarzania czynnoci
  int freq;

  public InterruptibleRepetitiveThread(String name, int f, Command com) {
    super(name);
    command = com;
    freq = f;
  }

  public void run() {
    // Tu ptla nieskoczona, mona doda warianty
    // np. powtrzenie ile razy
    while (true) {
      // Wykonanie czynnoci.
      // Zaoenie: synchronizacja dostpu do jakich wspldzielonych
      // obiektw - na poziomie definicji metody execute()!!!
      command.execute();

      // Umoliwienie zakoczenia pracy wtku
      synchronized(waitMutex) {
        try {
          waitMutex.wait(freq);
        } catch (InterruptedException exc) {
            System.out.println(getName() +  " - interrupted");
            return;
        }
       }
    }
  }

}

