// Klasa, okrelajca przestrzenie 
// na ktrych pisz przepisywacze
// oraz grupujca te przestrzenie w oknie.
// Kady przepisywacz wypisuje tekst 
// do wielowierszowego pola edycyjnego (TextArea z pakietu AWT)
// do czego suy mu metoda writeLine.
// Wszystkie przestrzenie grupowane s w oknie frame.

import java.awt.*;
import java.awt.event.*;

public class SpaceToWrite extends TextArea {
  
  private static Frame frame = new Frame("Write space");
  
  // Konstruktor: tworzy now przetrze pisania dla jednego przepisywacza
  public SpaceToWrite(int rows, int cols) {
    super(rows, cols);  // utworzenie TextArea  - z podan liczb wierszy, kolumn 
    frame.add(this);    // dodanie TextArea do okna
  }
  
  // Metoda dopisujca nowy wiersz do textarea
  public void writeLine(String s) {
    this.append(s + '\n');
  }

  // Metoda ustalajca uoenie pl edycyjnych w oknie
  // rozmiar okna (pack daje rozmiar taki jak akurat potrzreba)
  // i pokazujca okno    
  public static void show(int numWriters) {
    frame.setLayout(new GridLayout(0, numWriters));  
    frame.pack();
    frame.show();
    
    // Umoliwienie zakoczenia aplikacji poprzez zamknicie okna
    frame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        frame.dispose();
        System.exit(1);
      }
    });
  }  

  
}